import indigo
import string


#
# Print library version - added optional return in 2.0.1
#
def libVersion (returnval = False):
	ver = "2.0.2"
	if returnval: return ver
	
	indigo.server.log ("##### EPS LIB %s #####" % ver)
		
	
# Check validity of a value in a dictionary 2.0.1
def valueValid (dict, value, ifBlank=False):
	if dict:
		if value != "":
			if value in dict:
				if ifBlank:
					if unicode(dict[value]) != "": return True
				else:
					return True
					
	return False
	
#
# Get value of dictionary key if valid
#
def getDictValue (dict, value):
	if dict:
		if value:
			if value in dict:
				return dict[value]
				
	return "No value"
					
#
# Check validity of a state on a device
#
def stateValid (dev, value, ifBlank=False):
	if dev.states: return valueValid (dev.states, value, ifBlank)
	return False
	
	# DEPRECIATED - REDIRECT TO valueValid (2.0.1)
	
	
	if dev.states:
		if value in dev.states:
			if ifBlank:
				if unicode(dev.states[value]) != "": return True
			else:
				return True
	
	return False
		
#
# Check validity of a plugin prop on a device
#
def propValid (dev, value, ifBlank=False):
	if dev.pluginProps: return valueValid (dev.pluginProps, value, ifBlank)
	return False
	
	# DEPRECIATED - REDIRECT TO valueValid (2.0.1)
	
	if dev.pluginProps:
		if value in dev.pluginProps:
			if ifBlank:
				if unicode(dev.pluginProps[value]) != "": return True
			else:
				return True
	
	return False
		
#
# Check if a device is newly created - 2.0.2
#
def isNewDevice (origDev, newDev):
	if len(origDev.pluginProps) == 0 and len(newDev.pluginProps) != 0: return True
	
	return False
		
#
# Check if props changed between devices
#
def propsChanged (origDev, newDev):
	if origDev.pluginProps and newDev.pluginProps:
		for propName, propValue in origDev.pluginProps.iteritems():
			if newDev.pluginProps[propName] != propValue: return True
					
	return False
	
#
# Convert celsius to fahrenheit and fahrenheit to celsius 2.0.1
#
def convertTemperature (value, convertC = False, precision = 1):
	if convertC:
		# Convert value to celsius
		value = float(value)
		value = (value - 32) / 1.8000
		value = round(value, precision)
		
		if precision == 0: return int(value)
		
		return value
		
	else:
		# Default: convert value to fahrenheit
		value = float(value)
		value = (value * 1.8000) + 32
		value = round(value, precision)
		
		if precision == 0: return int(value)
		
		return value
		
#
# Return debug header 1 - 2.0.1
#
def debugHeader (label, character = "#"):
	# Return 69 character strings
	ret =  "\n\n" + debugHeaderEx(character)
	ret += debugLine(label, character)
	ret += debugHeaderEx(character)

	return ret

#
# Return debug header 2 - 2.0.1
#
def debugHeaderEx (character = "#"):
	# Return 69 character strings
	
	if character == "#":
		ret =  "#####################################################################\n"
			
	elif character == "=":
		ret =  "=====================================================================\n"
			
	elif character == "-":
		ret =  "---------------------------------------------------------------------\n"
			
	elif character == "+":
		ret =  "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n"
				
	elif character == "*":
		ret =  "*********************************************************************\n"
		
	elif character == "!":
		ret =  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n"
		
	return ret

#
# Return debug line - 2.0.1
#	
def debugLine (label, character = "#"):
	# Return 69 character strings
	return "%s %s %s\n" % (character, label.ljust(65), character)
	
	
	
	
	
	
	
	
	
	
	
	
	